#!/usr/bin/python
# Crystal Monitor 7.0
#-----------------------------------------------------
# Python Extension for Crystal Monitor
# Original author:Dennis Nordheimer (dennord at gmx.de)
# Modifed by: Mihael Simonic (smihael at gmail.com)
#------------------------------------------------------
import myinput as input
import karamba,os,time
import urllib2,re
homepath = os.environ['HOME']+'/.superkaramba/Crystal/'
iconpath = os.environ['HOME']+'/.superkaramba/Crystal/themes/'
temp = os.environ['HOME']+'/.superkaramba/Crystal/themes/temp/'
part1=None
part2=None
part3=None
part4=None
mem=None
temp=None
info=""
net=""
c1=""
c2=""
clicked=0
infopan=""
mi=""

class Partition:
	def __init__(self, widget,y, name, mount):
		self.name = karamba.createText(widget, 60, y, 40, 12, name)
		self.mps = karamba.createText(widget, 260, y, 100, 12, "")
		self.mpp = karamba.createText(widget, 174, y, 40, 12, "")
		karamba.setTextAlign(widget, self.mpp, "RIGHT")
		karamba.setTextSensor(widget, self.mps, 'sensor=disk format="%u of %t MB" mountpoint='+mount+ ' interval=12000')
		karamba.setTextSensor(widget, self.mpp, 'sensor=disk format="(%up%)" mountpoint='+mount+ ' interval=12000')
		self.barBg = karamba.createImage(widget,105,y+1,homepath+'img/bar/blackbg.png')
		karamba.hideImage(widget,self.barBg)
		self.bar = karamba.createBar(widget,106,y+2,82,6,homepath+'img/bar/default.png')
		karamba.setBarSensor(widget, self.bar, 'sensor=disk mountpoint='+mount + ' interval=12000')
		karamba.hideBar(widget,self.bar)
		
		
	def hide(self, widget):
		karamba.hideText(widget, self.name)
		karamba.hideText(widget, self.mps)
		karamba.hideText(widget, self.mpp)
		karamba.hideImage(widget,self.barBg)
		karamba.hideBar(widget,self.bar)
	
	def displayAsBar(self, widget):
		karamba.hideText(widget, self.mps)
		karamba.showImage(widget, self.barBg)
		karamba.showText(widget, self.mpp)
		karamba.showText(widget, self.name)
		karamba.showBar(widget, self.bar)
		mistr=homepath+'img/bar/'+input.readData(3,11)+'bg.png'
		karamba.setImagePath(widget,self.barBg,mistr)
		mistr2=homepath+'img/bar/'+input.readData(3,10)+'.png'
		karamba.setBarImage(widget,self.bar,mistr2)
		
	
	def update(self, widget,value,mp):
		karamba.changeText(widget, self.name,value)
		mod='u'
		if input.readData(3,12)=="free":
			mod='f'
		karamba.setTextSensor(widget, self.mps, 'sensor=disk format="%'+mod+' of %t MB" mountpoint='+mp+ ' interval=12000')
		karamba.setTextSensor(widget, self.mpp, 'sensor=disk format="(%'+mod+'p%)" mountpoint='+mp+ ' interval=12000')
		karamba.setBarSensor(widget, self.bar, 'sensor=disk format=%'+mod+' mountpoint='+mp + ' interval=12000')
			
	def show(self, widget):
		karamba.showText(widget, self.name)
		karamba.showText(widget, self.mps)
		karamba.showText(widget, self.mpp)
		karamba.hideImage(widget,self.barBg)
		karamba.hideBar(widget,self.bar)
	
	def move(self,widget,yPos):
		karamba.moveText(widget,self.name,60,yPos)
		karamba.moveText(widget,self.mps,105,yPos)
		karamba.moveText(widget,self.mpp,194,yPos)
		karamba.moveImage(widget,self.barBg,105,yPos+1)
		karamba.moveBar(widget,self.bar,106,yPos+2)
	
	def changeColors(self,widget,col1,col2):
		col1=col1.split(',')
		col2=col2.split(',')
		karamba.changeTextColor(widget,self.name,int(col1[0]),int(col1[1]),int(col1[2]))
		karamba.changeTextColor(widget,self.mps,int(col1[0]),int(col1[1]),int(col1[2]))
		karamba.changeTextColor(widget,self.mpp,int(col2[0]),int(col2[1]),int(col2[2]))
	
	def changeFont(self,widget,fo,size,shadow):
		karamba.changeTextFont(widget, self.name, fo)
		karamba.changeTextFont(widget, self.mps, fo)
		karamba.changeTextFont(widget, self.mpp, fo)
		karamba.changeTextSize(widget, self.name, size)
		karamba.changeTextSize(widget, self.mps, size)
		karamba.changeTextSize(widget, self.mpp, size) 
		karamba.changeTextShadow(widget,self.name,shadow)
		karamba.changeTextShadow(widget,self.mps,shadow)
		karamba.changeTextShadow(widget,self.mpp,shadow)

class Memory:
	def __init__(self, widget):
		self.ram = karamba.createText(widget, 60, 166, 40, 12, "RAM:")
		self.swap = karamba.createText(widget, 60, 179, 40, 12, "Swap:")
		self.ram2 = karamba.createText(widget, 104, 166, 130, 12, "")
		self.ram3 = karamba.createText(widget, 182, 166, 130, 12,"")
		self.swap2 = karamba.createText(widget, 104, 179, 130, 12, "")
		self.swap3 = karamba.createText(widget, 182, 179, 130, 12, "")
		karamba.setTextSensor(widget, self.swap2, 'sensor=memory format="%us of %ts Mb used" interval=12000')
		self.barBg = karamba.createImage(widget,85,228,homepath+'img/bar/blackbg.png')
		karamba.hideImage(widget,self.barBg)
		self.bar = karamba.createBar(widget,86,229,82,6,homepath+'img/bar/default.png')
		karamba.setBarSensor(widget, self.bar, 'sensor=memory format="%umb" interval=12000')
		karamba.hideBar(widget,self.bar)
		self.barBg2 = karamba.createImage(widget,85,241,homepath+'img/bar/blackbg.png')
		karamba.hideImage(widget,self.barBg2)
		self.bar2 = karamba.createBar(widget,86,242,82,6,homepath+'img/bar/default.png')
		karamba.setBarSensor(widget, self.bar2, 'sensor=memory format="%us" interval=12000')
		karamba.hideBar(widget,self.bar2)
	def hide(self, widget):
		karamba.hideText(widget, self.name)
		karamba.hideText(widget, self.mps)
		karamba.hideText(widget, self.mpp)
		karamba.hideImage(widget,self.barBg)
		karamba.hideBar(widget,self.bar)
	
	def displayAsBar(self, widget):
		karamba.hideText(widget, self.ram2)
		karamba.hideText(widget, self.swap2)
		karamba.showImage(widget, self.barBg)
		karamba.showImage(widget, self.barBg2)
		karamba.showText(widget, self.ram)
		karamba.showText(widget, self.swap)
		karamba.showText(widget, self.swap3)
		karamba.showText(widget, self.ram3)
		karamba.showBar(widget, self.bar)
		karamba.showBar(widget, self.bar2)
		mistr=homepath+'img/bar/'+input.readData(3,11)+'bg.png'
		karamba.setImagePath(widget,self.barBg,mistr)
		karamba.setImagePath(widget,self.barBg2,mistr)
		mistr2=homepath+'img/bar/'+input.readData(3,10)+'.png'
		karamba.setBarImage(widget,self.bar,mistr2)
		karamba.setBarImage(widget,self.bar2,mistr2)
		
	
	def update(self, widget):
		mod='u'
		if input.readData(3,12)=="free":
			mod='f'
		str1='sensor=program program="echo `free -m  |grep ^.*cache:| awk \'{ print $3 }\'` of `free -m  |grep Mem:| awk \'{ print $2 }\'` Mb used "'
		str11='sensor=program program="echo `free -m  |grep ^.*cache:| awk \'{ print $4 }\'` of `free -m  |grep Mem:| awk \'{ print $2 }\'` Mb free "'
		str2='sensor=program program="z1=`free -m |grep ^.*cache:| awk \'{ print $3 }\'` && z2=`free -m |grep Mem:| awk \'{ print $2 }\'` && z3=`expr $z1 \* 100 \/ $z2` && echo \($z3%\)"'
		str22='sensor=program program="z1=`free -m |grep ^.*cache:| awk \'{ print $4 }\'` && z2=`free -m |grep Mem:| awk \'{ print $2 }\'` && z3=`expr $z1 \* 100 \/ $z2` && echo \($z3%\)"'
		str3='sensor=program program="z1=`free -m |grep Swap:| awk \'{ print $3 }\'` && z2=`free -m |grep Swap:| awk \'{ print $2 }\'` && z3=`expr $z1 \* 1000 \/ $z2` && z4=`expr $z1 \* 100 \/ $z2` ;  if [ $z3 -lt 10 ]; then echo \(0.$z3%\) ; else echo \($z4%\) ; fi; "'
		str33='sensor=program program="z1=`free -m |grep Swap:| awk \'{ print $4 }\'` && z2=`free -m |grep Swap:| awk \'{ print $2 }\'` && z3=`expr $z1 \* 1000 \/ $z2` && z4=`expr $z1 \* 100 \/ $z2` ;  if [ $z3 -lt 10 ]; then echo \(0.$z3%\) ; else echo \($z4%\) ; fi; "'
		if mod=="u":
			karamba.setTextSensor(widget, self.swap2, 'sensor=memory format="%us of %ts Mb used" interval=12000')
			karamba.setTextSensor(widget, self.ram2, str1)
			karamba.setTextSensor(widget, self.ram3, str2)
			karamba.setTextSensor(widget, self.swap3, str3)
		else:
			karamba.setTextSensor(widget, self.swap2, 'sensor=memory format="%fs of %ts Mb free" interval=12000')
			karamba.setTextSensor(widget, self.ram2, str11)
			karamba.setTextSensor(widget, self.ram3, str22)
			karamba.setTextSensor(widget, self.swap3, str33)
		
		karamba.setBarSensor(widget, self.bar2, 'sensor=memory format="%'+mod+'s" interval=12000')
		karamba.setBarSensor(widget, self.bar, 'sensor=memory format="%'+mod+'mb" interval=12000')
			
	def show(self, widget):
		karamba.showText(widget, self.ram)
		karamba.showText(widget, self.swap)
		karamba.showText(widget, self.ram2)
		karamba.showText(widget, self.swap2)
		karamba.hideText(widget, self.swap3)
		karamba.hideText(widget, self.ram3)
		karamba.hideImage(widget,self.barBg)
		karamba.hideBar(widget,self.bar)
		karamba.hideImage(widget,self.barBg2)
		karamba.hideBar(widget,self.bar2)
	

	def changeColors(self,widget,col1,col2):
		col1=col1.split(',')
		col2=col2.split(',')
		karamba.changeTextColor(widget,self.ram,int(col1[0]),int(col1[1]),int(col1[2]))
		karamba.changeTextColor(widget,self.swap,int(col1[0]),int(col1[1]),int(col1[2]))
		karamba.changeTextColor(widget,self.ram2,int(col1[0]),int(col1[1]),int(col1[2]))
		karamba.changeTextColor(widget,self.swap2,int(col1[0]),int(col1[1]),int(col1[2]))
		karamba.changeTextColor(widget,self.swap3,int(col2[0]),int(col2[1]),int(col2[2]))
		karamba.changeTextColor(widget,self.ram3,int(col2[0]),int(col2[1]),int(col2[2]))
	
	def changeFont(self,widget,fo,size,shadow):
		karamba.changeTextFont(widget, self.ram, fo)
		karamba.changeTextFont(widget, self.swap, fo)
		karamba.changeTextFont(widget, self.ram2, fo)
		karamba.changeTextFont(widget, self.swap2, fo)
		karamba.changeTextFont(widget, self.swap3, fo)
		karamba.changeTextFont(widget, self.ram3, fo)
		karamba.changeTextSize(widget, self.ram, size)
		karamba.changeTextSize(widget, self.swap, size)
		karamba.changeTextSize(widget, self.ram2, size)
		karamba.changeTextSize(widget, self.swap2, size)
		karamba.changeTextSize(widget, self.ram3, size)
		karamba.changeTextSize(widget, self.swap3, size)
		karamba.changeTextShadow(widget,self.ram,shadow)
		karamba.changeTextShadow(widget,self.swap,shadow)
		karamba.changeTextShadow(widget,self.ram2,shadow)
		karamba.changeTextShadow(widget,self.swap2,shadow)
		karamba.changeTextShadow(widget,self.ram3,shadow)
		karamba.changeTextShadow(widget,self.swap3,shadow)
#class CpuTemp:
	#def __init__(self,widget):
		#self.label1 = karamba.createText(widget, 44, 127, 40, 12, input.readData(6,1))
		#self.sens1= karamba.createText(widget, 80, 127, 40, 12, "")
		
	#def update(self,widget):
		#karamba.changeText(widget, self.label1,input.readData(6,1))
		#str1='sensor=program program="sensors |grep '+input.readData(6,2)+' | awk \'{ print $2 }\' |sed s/+//"'
		#karamba.setTextSensor(widget, self.sens1,str1)
		
	#def changeColors(self,widget,col1,col2):
		#col1=col1.split(',')
		#col2=col2.split(',')
		#karamba.changeTextColor(widget,self.label1,int(col1[0]),int(col1[1]),int(col1[2]))
		#karamba.changeTextColor(widget,self.sens1,int(col2[0]),int(col2[1]),int(col2[2]))

	#def changeFont(self,widget,fo,size,shadow):
		#karamba.changeTextFont(widget, self.label1, fo)
		#karamba.changeTextFont(widget, self.sens1, fo)
		#karamba.changeTextSize(widget, self.label1, size)
		#karamba.changeTextSize(widget, self.sens1, size)
		#karamba.changeTextShadow(widget, self.label1, shadow)
		#karamba.changeTextShadow(widget, self.sens1, shadow)

def setTransparency(img,value,asImg):
	command='convert '+img+' -channel A -fx u*'+value+asImg
	os.system(command)

def changeTextProps(widget,text,cl,font,sz,shad,sensorText):
	karamba.changeTextColor(widget,text,int(cl[0]),int(cl[1]),int(cl[2]))
	karamba.changeTextFont(widget, text, font)
	karamba.changeTextSize(widget, text, sz) 
	karamba.changeTextShadow(widget,text,shad)
	if len(sensorText)>2:
		karamba.setTextSensor(widget,text,sensorText)

def widgetUpdated(widget):
	global part1, part2, part3, part4,mem,temp,net,c1,c2,size2,fo2,shadow2,col,col1
	
	#update partitions
	myList=[]
	if len(input.readData(3,1))>0:
		if input.readData(3,9) =="bar":
			part1.displayAsBar(widget)
		else:
			part1.show(widget)
		part1.update(widget,input.readData(3,1),input.readData(3,5))
		myList.append(part1)
	else:
		part1.hide(widget)
		
	if len(input.readData(3,2))>0:
		if input.readData(3,9) =="bar":
			part2.displayAsBar(widget)
		else:
			part2.show(widget)
		part2.update(widget,input.readData(3,2),input.readData(3,6))
		myList.append(part2)
	else:
		part2.hide(widget)
		
	if len(input.readData(3,3))>0:
		if input.readData(3,9) =="bar":
			part3.displayAsBar(widget)
		else:
			part3.show(widget)
		part3.update(widget,input.readData(3,3),input.readData(3,7))
		myList.append(part3)
	else:
		part3.hide(widget)

	if len(input.readData(3,4))>0:
		if input.readData(3,9) =="bar":
			part4.displayAsBar(widget)
		else:
			part4.show(widget)
		part4.update(widget,input.readData(3,4),input.readData(3,8))
		myList.append(part4)
	else:
		part4.hide(widget)
		
	dist=1
	if len(myList)<4 and len(myList) is not 0:
		dist=15/len(myList)

	h=0
	for part in myList:
		part.move(widget,276+h+dist)
		h=9+h
	
	#ram/swap
	if len(input.readData(3,1))>0:
		if input.readData(3,9) =="bar":
			mem.displayAsBar(widget)
		else:
			mem.show(widget)
		mem.update(widget)
	#temp
	#temp.update(widget)
	
	#update
	#####header
	col=input.readData(2,1).split(',')
	i1 = karamba.getThemeText(widget, "i1")
	i2 = karamba.getThemeText(widget, "i2")
	i3 = karamba.getThemeText(widget, "i3")
	fo1= input.readData(5,1)
	size1=int(input.readData(5,2))
	if input.readData(5,3)=="True":
		shadow1=1
	else:
		shadow1=0
	changeTextProps(widget,i1,col,fo1,size1,shadow1,"")
	changeTextProps(widget,i2,col,fo1,size1,shadow1,"")
	changeTextProps(widget,i3,col,fo1,size1,shadow1,"") 
	
	#####Timer
	c11 = karamba.getThemeText(widget, "cr11")
	fo2= input.readData(5,4)
	size2=int(input.readData(5,5))
	if input.readData(5,6)=="True":
		shadow2=1
	else:
		shadow2=0
	col1=input.readData(2,2).split(',')
	changeTextProps(widget,c11,col,fo2,size2,shadow2,"")
	c11 = karamba.getThemeText(widget, "cr12")
	changeTextProps(widget,c11,col,fo2,size2,shadow2,"")
	c11 = karamba.getThemeText(widget, "cr13")
	changeTextProps(widget,c11,col,fo2,size2,shadow2,"")
	c11 = karamba.getThemeText(widget, "cr14")
	changeTextProps(widget,c11,col,fo2,size2,shadow2,"")
	c12 = karamba.getThemeText(widget, "cr15")
	changeTextProps(widget,c12,col,fo2,size2,shadow2,"")
	c12 = karamba.getThemeText(widget, "cr16")
	changeTextProps(widget,c12,col,fo2,size2,shadow2,"")
		
	#####core0
	c21 = karamba.getThemeText(widget, "cr21")
	changeTextProps(widget,c21,col,fo2,size2,shadow2,"")
	c21 = karamba.getThemeText(widget, "cr22")
	changeTextProps(widget,c21,col,fo2,size2,shadow2,"")
	c21 = karamba.getThemeText(widget, "cr24")
	changeTextProps(widget,c21,col,fo2,size2,shadow2,"")
	c22 = karamba.getThemeText(widget, "cr23")
	changeTextProps(widget,c22,col1,fo2,size2,shadow2,"")
	c22 = karamba.getThemeText(widget, "cr25")
	changeTextProps(widget,c22,col1,fo2,size2,shadow2,"")
	c22 = karamba.getThemeText(widget, "cr29")
	karamba.changeTextColor(widget,c22,int(col1[0]),int(col1[1]),int(col1[2]))
	karamba.changeTextShadow(widget,c22,shadow2)
	#graph2
	gr2=karamba.getThemeGraph(widget,"cr28")
	karamba.setGraphColor(widget, gr2, int(col1[0]),int(col1[1]),int(col1[2]))
	
	#####NET
	col2=input.readData(2,3).split(',')
	n1 = karamba.getThemeText(widget, "n1")
	changeTextProps(widget,n1,col2,fo2,size2,shadow2,"")
	n2 = karamba.getThemeText(widget, "n2")
	changeTextProps(widget,n2,col1,fo2,size2,shadow2,"")
	#graph3
	gr3=karamba.getThemeGraph(widget,"n3")
	karamba.setGraphColor(widget, gr3, int(col2[0]),int(col2[1]),int(col2[2]))
	#grap4
	gr4=karamba.getThemeGraph(widget,"n4")
	karamba.setGraphColor(widget, gr4, int(col1[0]),int(col1[1]),int(col1[2]))
	
	mi1=input.readData(4,1)
	mi2=input.readData(4,2)
	mi3=input.readData(4,3)
	mi4=input.readData(4,4)
	
	if mi4 =="yes":
		karamba.setTextSensor(widget, n1, 'sensor=network device='+mi1+' format="%out KB/s"')
		karamba.setTextSensor(widget, n2, 'sensor=network device='+mi1+' format="%in KB/s"')
		karamba.setGraphSensor(widget,gr3, 'sensor=network device='+mi1+' format="%out" interval=500')
		karamba.setGraphSensor(widget,gr4, 'sensor=network device='+mi1+' format="%in" interval=500')
		karamba.setGraphMinMax(widget,gr3,0,int(mi3))
		karamba.setGraphMinMax(widget,gr4,0,int(mi2))
		input.writeNetData(mi1,mi2,mi3,"no")
	
	######Temp
	#temp.changeColors(widget,input.readData(2,1),input.readData(2,2))
	#temp.changeFont(widget,fo2,size2,shadow2)
	#####RAM/Swap
	mem.changeColors(widget,input.readData(2,1),input.readData(2,2))
	mem.changeFont(widget,fo2,size2,shadow2)
	
	#####Partitions
	part1.changeColors(widget,input.readData(2,1),input.readData(2,2))
	part2.changeColors(widget,input.readData(2,1),input.readData(2,2))
	part3.changeColors(widget,input.readData(2,1),input.readData(2,2))
	part4.changeColors(widget,input.readData(2,1),input.readData(2,2))
	part1.changeFont(widget,fo2,size2,shadow2)
	part2.changeFont(widget,fo2,size2,shadow2)
	part3.changeFont(widget,fo2,size2,shadow2)
	part4.changeFont(widget,fo2,size2,shadow2)
	
	#####Grid
	grid=input.readData(1,3)
	gr2=karamba.getThemeImage(widget,"gridCr2")
	gr3=karamba.getThemeImage(widget,"gridNet")
	karamba.setImagePath(widget,gr2,homepath+'themes/'+grid)
	karamba.setImagePath(widget,gr3,homepath+'themes/'+grid)
	#####Icons
	set=input.readData(1,2)
	c1=karamba.getThemeImage(widget,"c1")
	c2=karamba.getThemeImage(widget,"c2")
	net=karamba.getThemeImage(widget,"net")
	netUp=karamba.getThemeImage(widget,"netUp")
	netDown=karamba.getThemeImage(widget,"netDown")
	ram=karamba.getThemeImage(widget,"ram")
	hdd=karamba.getThemeImage(widget,"hdd")
	karamba.setImagePath(widget,c1,iconpath+set+"/timer.png")
	karamba.setImagePath(widget,c2,iconpath+set+"/cpu.png")
	karamba.setImagePath(widget,net,iconpath+set+"/net.png")
	#karamba.setImagePath(widget,netUp,iconpath+set+"/up.png")
	#karamba.setImagePath(widget,netDown,iconpath+set+"/down.png")
	karamba.setImagePath(widget,ram,iconpath+set+"/memory.png")
	karamba.setImagePath(widget,hdd,iconpath+set+"/hdd.png")
	
	#####BG
	bg=homepath+"themes/default.png"
	if len(input.readData(1,1))>0:
		bg=homepath+"themes/"+input.readData(1,1)
	nm=karamba.getThemeImage(widget,"bg")
	##transparency
	trBg=homepath+"themes/temp/"+input.readData(1,1)
	if float(input.readData(1,4))<1 and input.readData(1,1) is not 'glass.png':
		command='convert '+bg+' -channel A -fx u*'+input.readData(1,4)+' '+trBg
		os.system(command)
		karamba.setImagePath(widget,nm,trBg)
	else:
		karamba.setImagePath(widget,nm,bg)

	
	#ClickArea
	karamba.attachClickArea(widget,net)
	karamba.attachClickArea(widget,c2)

	karamba.redrawWidget(widget)
	
def initWidget(widget):
	global part1,part2,part3,part4,net,c2,size2,fo2,shadow2,col,col1,mem,temp

	if os.path.exists(homepath) == False: 
		os.system("cp -r "+karamba.getThemePath(widget)+ " "+os.environ['HOME']+"/.superkaramba/")
		
	#Translate
	karamba.addMenuConfigOption(widget, "settings", "Configure Theme")
	karamba.setMenuConfigOption(widget,"settings", 0)

	bg="themes/default.png"
	if len(input.readData(1,1))>0:
		bg="themes/"+input.readData(1,1)
	nm=karamba.getThemeImage(widget,"bg")
	karamba.setImagePath(widget,nm,bg)

	part1=Partition(widget,277,input.readData(3,1),input.readData(3,5)) 
	part2=Partition(widget,286,input.readData(3,2),input.readData(3,6)) 
	part3=Partition(widget,295,input.readData(3,3),input.readData(3,7))
	part4=Partition(widget,304,input.readData(3,4),input.readData(3,8))
	mem=Memory(widget)
	input.writeSensors(input.readData(6,1),input.readData(6,2),input.readData(6,3),input.readData(6,4))
	temp=CpuTemp(widget)
	mi1=input.readData(4,1)
	mi2=input.readData(4,2)
	mi3=input.readData(4,3)
	input.writeNetData(mi1,mi2,mi3,"yes")
	
def menuOptionChanged(widget, key, value):
	karamba.setMenuConfigOption(widget,"settings",0)	
	command = ["python",homepath+"settings.py"]
	karamba.executeInteractive(widget, command)

#def getInetIP():
	#ipText="Unable to connect"
	#try:
		#ipText=urllib2.urlopen("http://www.wieistmeineip.de/").read()
		#ipText=re.search("[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}",ipText).group()
		
	#except:
		#pass
	#return ipText

def showText(widget,val):
	#global netIPA,netIP,netTxt,nw,iface,ifaceN,host,hostN,lip,lipN,downN,down,upload, uploadN,icon,proc,cache1,cache2,clock1,clock2,pr,ptop,top
	global icon,proc,cache1,cache2,clock1,clock2,pr,ptop,top
	#if val ==1:
		#str1="Internet:"
		#netTxt=karamba.createText(widget, 59, 160, 100, size2+2, str1)
		#changeTextProps(widget,netTxt,col,fo2,size2+2,shadow2,"")
		#icon=karamba.createImage(widget,55,173,homepath+'img/info.png')
		#karamba.addImageTooltip(widget, icon, "More info") 
		#karamba.attachClickArea(widget, icon)
		#str2="IP-Address: "
		#netIPA=karamba.createText(widget, 70, 175, 100, size2, str2)
		#karamba.changeTextColor(widget,netIPA,int(col[0]),int(col[1]),int(col[2]))
		#changeTextProps(widget,netIPA,col,fo2,size2,shadow2,"")
		#str3=getInetIP()
		#netIP=karamba.createText(widget, 132, 175, 100, size2, str3)
		#changeTextProps(widget,netIP,col1,fo2,size2,shadow2,"")
		#str3="Network: "
		#nw=karamba.createText(widget, 59, 190, 100, size2+2, str3)
		#changeTextProps(widget,nw,col,fo2,size2+2,shadow2,"")
		#str4="Interface: "
		#iface=karamba.createText(widget, 70, 217, 100, size2, str4)
		#changeTextProps(widget,iface,col,fo2,size2,shadow2,"")
		#ifaceN=karamba.createText(widget, 132, 217, 100, size2+2,input.readData(4,1))
		#changeTextProps(widget,ifaceN,col1,fo2,size2,shadow2,"")
		#str5="Host: "
		#host=karamba.createText(widget, 70, 205, 100, size2, str5)
		#changeTextProps(widget,host,col,fo2,size2,shadow2,"")
		#hostN=karamba.createText(widget, 132, 205, 100, size2,"")
		#st1='sensor=program program="uname -n" interval=120000'
		#changeTextProps(widget,hostN,col1,fo2,size2,shadow2,st1)
		#str6="IP-Address: "
		#lip=karamba.createText(widget, 70, 229, 100, size2, str6)
		#changeTextProps(widget,lip,col,fo2,size2,shadow2,"")
		#lipN=karamba.createText(widget, 132, 229, 100, size2, "")
		#st2='sensor=program program="/sbin/ifconfig '+input.readData(4,1)+' | grep \'inet A.*:\'|awk \'{print $2}\'| sed s/^.*://|line 1"'
		#changeTextProps(widget,lipN,col1,fo2,size2,shadow2,st2)
		#str7="Download: "
		#downN=karamba.createText(widget, 70, 242, 100, size2, str7)
		#changeTextProps(widget,downN,col,fo2,size2,shadow2,"")
		#str8="Upload: "
		#uploadN=karamba.createText(widget, 70, 254, 100, size2, str8)
		#changeTextProps(widget,uploadN,col,fo2,size2,shadow2,"")
		#st3='sensor=program program="/sbin/ifconfig '+input.readData(4,1)+' | grep \'RX byte\' | awk \'{print $3 $4}\'| sed s/^\(//|sed s/\)//"'
		#down=karamba.createText(widget, 132, 242, 100, size2, "")
		#changeTextProps(widget,down,col1,fo2,size2,shadow2,st3)
		#st4='sensor=program program="/sbin/ifconfig '+input.readData(4,1)+' | grep \'RX byte\' | awk \'{print $7 $8}\'| sed s/^\(//|sed s/\)//"'
		#upload=karamba.createText(widget, 132, 254, 100, size2, "")
		#changeTextProps(widget,upload,col1,fo2,size2,shadow2,st4)
		
			
	
	if val==2:
		str11='sensor=program program="cat /proc/cpuinfo | grep \'model name\' |head -1|sed -e \'s/^.*: //\' |sed -e \'s/   .*//\'"'
		proc=karamba.createText(widget, 55, 49, 150, size2+2, "")
		changeTextProps(widget,proc,col,fo2,size2+1,shadow2,str11)
		clock1=karamba.createText(widget, 70, 60, 80, size2+2, "Frequency: ")
		changeTextProps(widget,clock1,col,fo2,size2,shadow2,"")
		str12='sensor=program program="cat /proc/cpuinfo | grep \'cpu MHz\' | sed -e \'s/.*: //\'| sed -e \'s/\..../ MHz/\' | line 1\"'
		clock2=karamba.createText(widget, 138, 60, 80, size2+2, "")
		changeTextProps(widget,clock2,col1,fo2,size2,shadow2,str12)
		cache1=karamba.createText(widget, 70, 71, 80, size2+2, "Cache size: ")
		changeTextProps(widget,cache1,col,fo2,size2,shadow2,"")
		str13='sensor=program program="cat /proc/cpuinfo | grep \'^cache\' |head -1|sed -e \'s/^.*: //\'"'
		cache2=karamba.createText(widget, 138, 71, 80, size2+2, "")
		changeTextProps(widget,cache2,col1,fo2,size2,shadow2,str13)
		pr=karamba.createText(widget, 55, 91, 120, size2+2, "Processes:")
		changeTextProps(widget,pr,col,fo2,size2+1,shadow2,"")
		str14='sensor=program program="ps axo comm --sort -pcpu | head -n5|tail -n4" interval=2000'
		top=karamba.createText(widget, 70, 105, 120, size2+2, "")
		karamba.setTextAlign(widget,top,'LEFT')
		changeTextProps(widget,top,col,fo2,size2,shadow2,str14)
		str15='sensor=program program="ps axo pcpu --sort -pcpu | head -n5|tail -n4 |grep \'^.*\' |sed -e \'s/\.*$/ %/\'" interval=2000'
		ptop=karamba.createText(widget, 70, 105, 120, size2+2, "")
		karamba.setTextAlign(widget,ptop,'RIGHT')
		changeTextProps(widget,ptop,col1,fo2,size2,shadow2,str15)
		
		

def showInfo(widget, val):
	global info,clicked,closeIcon
	if val==1:
		info = karamba.createImage(widget,43,140,homepath+'themes/infoimg/'+input.readData(1,1))
		showText(widget,1)
		
	if val==2:
		info = karamba.createImage(widget,43,25,homepath+'themes/infoimg/'+input.readData(1,1))
		showText(widget,2)

	karamba.resizeImage(widget, info,1,136)
	for i in range(22):
		karamba.resizeImage(widget, info,i*8,136)
          	karamba.redrawWidget(widget)
		if i==21:
			if val==1:
				closeIcon = karamba.createImage(widget,190,144,homepath+'themes/close.png')
			else:
				closeIcon = karamba.createImage(widget,190,29,homepath+'themes/close.png')
		time.sleep(0.01)

	karamba.addImageTooltip(widget, closeIcon, "Close Info") 
	karamba.attachClickArea(widget, closeIcon)
	clicked=1
	
		
def closeInfo(widget,val):
	global info,clicked,netIP,netIPA,netTxt,mi
	try:
		closeMoreInfo(widget)
		mi="n"
	except:
		pass
	if val is "net":
		karamba.deleteText(widget,netIP)
		karamba.deleteText(widget,netTxt)
		karamba.deleteText(widget,netIPA)
		karamba.deleteImage(widget,icon)
		karamba.deleteText(widget,nw)
		karamba.deleteText(widget,iface)
		karamba.deleteText(widget,ifaceN)
		karamba.deleteText(widget,host)
		karamba.deleteText(widget,hostN)
		karamba.deleteText(widget,lip)
		karamba.deleteText(widget,lipN)
		karamba.deleteText(widget,down)
		karamba.deleteText(widget,downN)
		karamba.deleteText(widget,upload)
		karamba.deleteText(widget,uploadN)
		

	if val is "cpu":
		karamba.deleteText(widget,proc)
		karamba.deleteText(widget,clock1)
		karamba.deleteText(widget,clock2)
		karamba.deleteText(widget,cache1)
		karamba.deleteText(widget,cache2)
		karamba.deleteText(widget,pr)
		karamba.deleteText(widget,top)
		karamba.deleteText(widget,ptop)
				
	if val is "all":
		if infopan is "i1":
			karamba.deleteText(widget,netIP)
			karamba.deleteText(widget,netTxt)
			karamba.deleteText(widget,netIPA)
			karamba.deleteImage(widget,icon)
			karamba.deleteText(widget,nw)
			karamba.deleteText(widget,iface)
			karamba.deleteText(widget,ifaceN)
			karamba.deleteText(widget,host)
			karamba.deleteText(widget,hostN)
			karamba.deleteText(widget,lip)
			karamba.deleteText(widget,lipN)
			karamba.deleteText(widget,down)
			karamba.deleteText(widget,downN)
			karamba.deleteText(widget,upload)
			karamba.deleteText(widget,uploadN)
		
		if infopan is "i2" or infopan is "i3":
			karamba.deleteText(widget,proc)
			karamba.deleteText(widget,clock1)
			karamba.deleteText(widget,clock2)
			karamba.deleteText(widget,cache1)
			karamba.deleteText(widget,cache2)
			karamba.deleteText(widget,pr)
			karamba.deleteText(widget,top)
			karamba.deleteText(widget,ptop)
 	
	karamba.deleteImage(widget,closeIcon)
	for i in range(22):
		karamba.resizeImage(widget, info,176-(i+1)*8,136)
		
		if  i==21:
			karamba.deleteImage(widget,info)			
		karamba.redrawWidget(widget)
		time.sleep(0.001)

	clicked=0

def showMoreInfo(widget):
	global ipImg,close2Icon
	ipImg=karamba.createImage(widget,65,150,'http://www.wieistmeineip.de/ip-address/')
	close2Icon=karamba.createImage(widget,172,153,homepath+'img/close2.png')
	karamba.addImageTooltip(widget, close2Icon, "Close") 
	karamba.attachClickArea(widget, close2Icon)

def closeMoreInfo(widget):
	karamba.deleteImage(widget,close2Icon)
	karamba.deleteImage(widget,ipImg)


def widgetClicked(widget, x, y, button):
	pass

def widgetMouseMoved(widget, x, y, button):
	pass

def meterClicked(widget, meter, button):
	global infopan,mi
	if meter == net and clicked==0:
		showInfo(widget,1)
		infopan="i1"
	elif meter==net and clicked == 1 and infopan is not "i1":
		closeInfo(widget,"cpu")
		showInfo(widget,1)
		infopan="i1"
	if meter == c1 and clicked==0:
		showInfo(widget,2)
		infopan="i2"
	elif meter == c1 and clicked == 1 and infopan is not "i2" and infopan is not "i3":
		closeInfo(widget,"net")
		showInfo(widget,2)
		infopan="i2"
	if meter == c2 and clicked==0:
		showInfo(widget,2)
		infopan="i3"
	elif meter == c2 and clicked == 1 and infopan is not "i3" and infopan is not "i2":
		closeInfo(widget,"net")
		showInfo(widget,2)
		infopan="i3"
	if meter == closeIcon:
		closeInfo(widget,"all")
	if meter == icon and mi is not "y":
		showMoreInfo(widget)
		mi="y"
	if meter == close2Icon:
		closeMoreInfo(widget)
		mi="n"

			
